/**   
* @Title: IMManager.java 
* @Package com.hdp.customerservice 
* @Description: TODO
* @author new12304508_163_com   
* @date 2015年6月15日 下午2:59:46 
* @version V1.0   
*/
package com.hdp.customerservice.websocket;

import java.io.IOException;
import java.util.Iterator;
import java.util.concurrent.ConcurrentHashMap;

import javax.websocket.Session;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSON;
import com.hdp.customerservice.websocket.model.Customer;
import com.hdp.customerservice.websocket.model.Waiter;
import com.hdp.pi.wechat.model.BaseEntity;

@Component
public class IMManager {
	private static Log log=LogFactory.getLog(IMManager.class);
	
	public static ConcurrentHashMap<String,Customer> 
					users = new ConcurrentHashMap<String, Customer>();
	
	public static ConcurrentHashMap<String,Waiter> 
					waiters = new ConcurrentHashMap<String, Waiter>();
	
	public static void broadcast(String id,String message){
		Iterator<Waiter> ws= waiters.values().iterator();
		while(ws.hasNext()){
			try{
				Waiter w=(Waiter)ws.next();
				Session s=w.session;
				if(s!=null && s.isOpen() && w.id != id){
					s.getBasicRemote().sendText(message);
				}
			}catch(Throwable e){
			}
		}
	}
	
	public static void pushMessage(BaseEntity message) throws InterruptedException{
		String openId=message.openId;
		Customer user = users.get(openId);
		if(user == null){
			user = new Customer();
			user.openId= message.openId;
			user.waiter = waiters.get("lws");
			users.put(openId, user);
		}
		user.messages.put(message);
		BaseEntity m = user.messages.poll();
		if(user.waiter != null && user.waiter.session!=null && user.waiter.session.isOpen()){
			try {
				user.waiter.session.getBasicRemote().sendText(JSON.toJSONString(m));
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
